<#--*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2008 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************-->
<#assign classbody>
<#-- add remote class alias -->
public class ${entity.name} extends _Super_${entity.name}
{
    /** 
     * DO NOT MODIFY THIS STATIC INITIALIZER - IT IS NECESSARY
     * FOR PROPERLY SETTING UP THE REMOTE CLASS ALIAS FOR THIS CLASS
     *
     **/
     
    /**
     * Calling this static function will initialize RemoteClass aliases
     * for this value object as well as all of the value objects corresponding
     * to entities associated to this value object's entity.  
     */     
     public static function _initRemoteClassAlias() : void
     {
         <#if packageMap.get(entity.getName())??>
         _Super_${entity.name}.model_internal::initRemoteClassAliasSingle(${packageMap.get(entity.getName())}.${entity.name});
        <#else>
         _Super_${entity.name}.model_internal::initRemoteClassAliasSingle(${model.name}.${entity.name});        
        </#if>
         _Super_${entity.name}.model_internal::initRemoteClassAliasAllRelated();
     }
     
     model_internal static function initRemoteClassAliasSingleChild() : void 
     {
        <#if packageMap.get(entity.getName())??>
         _Super_${entity.name}.model_internal::initRemoteClassAliasSingle(${packageMap.get(entity.getName())}.${entity.name});
        <#else>
         _Super_${entity.name}.model_internal::initRemoteClassAliasSingle(${model.name}.${entity.name});        
        </#if>
     }
    
     {
        <#if packageMap.get(entity.getName())??>
         _Super_${entity.name}.model_internal::initRemoteClassAliasSingle(${packageMap.get(entity.getName())}.${entity.name});
        <#else>
         _Super_${entity.name}.model_internal::initRemoteClassAliasSingle(${model.name}.${entity.name});        
        </#if>
     }
    /** 
     * END OF DO NOT MODIFY SECTION
     *
     **/    
}
</#assign>
<#-- ====================================================================================== -->
/**
 * This is a generated sub-class of _${entity.name}.as and is intended for behavior
 * customization.  This class is only generated when there is no file already present
 * at its target location.  Thus custom behavior that you add here will survive regeneration
 * of the super-class. 
 *
 * NOTE: Do not manually modify the RemoteClass mapping unless
 * your server representation of this class has changed and you've 
 * updated your ActionScriptGeneration,RemoteClass annotation on the
 * corresponding entity 
 **/ 
 
<#if packageMap.get(entity.getName())??>
package ${packageMap.get(entity.getName())}
<#else>
package ${model.name}
</#if>
{

import com.adobe.fiber.core.model_internal;

${classbody}
}