<#--*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2008 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and may be covered by U.S. and Foreign Patents,
 * patents in process, and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************-->
<#assign classbody>  
[ExcludeClass]
internal class _Super_${service.name?cap_first} implements IFiberService
{  
    // Constructor
    public function _Super_${service.name?cap_first}()
    {
      // initialize RemoteClass alias for all entities returned by functions of this service
      <#list service.getFunctions() as function>
         <#-- initialize RemoteClass alias for all entities returned by functions of this service -->
        <#if function.getSignature().getReturnType().isEntity()>
            <#if packageMap.get(function.getSignature().getReturnType().getName())??>
     ${packageMap.get(function.getSignature().getReturnType().getName())}.${function.getSignature().getReturnType().getName()}._initRemoteClassAlias();
            <#else>
     ${model.name}.${function.getSignature().getReturnType().getName()}._initRemoteClassAlias();
            </#if>
        <#else>
            <#if function.getSignature().getReturnType().isCollectionType() && function.getSignature().getReturnType().getElementType().isEntity()>
                <#if packageMap.get(function.getSignature().getReturnType().getElementType().getName())??>
     ${packageMap.get(function.getSignature().getReturnType().getElementType().getName())}.${function.getSignature().getReturnType().getElementType().getName()}._initRemoteClassAlias();
                <#else>
     ${model.name}.${function.getSignature().getReturnType().getElementType().getName()}._initRemoteClassAlias();
                </#if>                
            </#if>   
        </#if>
       </#list>
    }

<#list service.getFunctions() as function>
<#if function.getReturnTypeExpression() == "void">
<#assign returnType>void</#assign>
<#else>
<#assign returnType>AsyncToken</#assign>
</#if>
    public function ${function.getName()}${typeHelper.format(function.getSignature())} : ${returnType}
    {
        throw new Error("Implementation for ${function.getName()} not provided");   
    }
</#list>
}
</#assign>
<#-- ====================================================================================== -->
/**
 * This is a generated class and is not intended for modfication.  To customize behavior
 * of this service wrapper you may modify the generated sub-class of this class - ${service.name}.as.
 */
<#if packageMap.get(service.getName())??>
package ${packageMap.get(service.getName())}
<#else>
package ${model.name}
</#if>
{

import mx.rpc.AsyncToken; 
import com.adobe.fiber.services.IFiberService;

<#list typeHelper.getImports() as imp>
    <#if imp??> 
import ${imp}
    </#if>
</#list>

${classbody}
}
